IMPLEMENTATION MODULE SKTime;

IMPORT SKGeneral,
       TimeBase;

PROCEDURE Delay(ms : INTEGER);
BEGIN
     TimeBase.SDL_Delay(ms);
END Delay;

PROCEDURE GetTicks() : SYSTEM.CARDINAL32;
BEGIN
RETURN TimeBase.SDL_GetTicks();
END GetTicks;

PROCEDURE AddTimer(interval : SYSTEM.CARDINAL32; callback : NewTimerCallback; param : SYSTEM.ADDRESS) : TimerID;
VAR timer : TimerID;
BEGIN
     timer := TimeBase.SDL_AddTimer(interval, callback, param);
     IF timer = NIL THEN SKGeneral.Raise(); END;
RETURN timer;
END AddTimer;

PROCEDURE RemoveTimer(id : TimerID);
VAR error : BOOLEAN;
BEGIN
     error := TimeBase.SDL_RemoveTimer(id);
     IF error = FALSE THEN SKGeneral.Raise(); END;
END RemoveTimer;

BEGIN
	SKGeneral.InitSubSystem(SKGeneral.InitTime);
END SKTime.
